/**********************************************************************
 * ֻѧϰʹãδɣκ;
 * ӲƬSTC12C5A60S2,Ƶ12MHZ
 * ˵ILI9341V 4ӲSPI
 
 ----------------------------------------------------
 |ǧһʾƼ޹˾                        |
 |˾վ:www.qytft.com                            |
 |Ավhttps://shop580133616.taobao.com        |
 |̻() :+86 0755-27908130                     |
 |ҵѯ:18823372746 (쾭 WXͬ)              |
 |ҵѯ:15989313508 (뾭 WXͬ)              |
 ----------------------------------------------------

 ----------------------------------------------------
 |˾ṩ֧֣κμ⻶ӭʱѧϰ    |
 |֧QQ:3597321058                             |
 |֧:qyxskj@126.com                       |
 |֧:13723763193ܹ WXͬţ               |
 |QQȺ:792027219                            |
 ----------------------------------------------------

 * ˵:
 ========================ԴŽ=======================================================        
 |   LCDģ           Ƭ                                                          |
 |     VCC      --->      5V        //Դ                                                 |
 |     GND      --->      GND       //Դ                                               |  
 |====================ƼŽ===================================================|
 |   LCDģ  			   Ƭ                                                          |
 |     CS       --->      P13       //ҺƬѡźţ͵ƽЧ                     |
 |     RS       --->      P12       //Һ/ݿźţ͵ƽߵƽݣ|
 |     RST      --->      P33       //Һλźţ͵ƽЧ                     |
 |     SCL      --->      P17       //ҺSPIʱź                                |
 |     SDI      --->      P15       //ҺSPIдź                              |
 |     SDO      --->      P16       //ҺSPI߶ź                              |
 ===========================================================================================
 
 * :2020/5/13
 * 汾V1.0
 * ȨУؾ
 * Copyright(C) ǧһʾƼ޹˾ 2020-2035
 * All rights reserved
**********************************************************************/
#include "main.h"

u16 width=LCD_W;
u16 height=LCD_H;

void delay_ms(int count)  // /* X1ms */
{
    int i,j;
	for(i=0;i<count;i++)
        for(j=0;j<1000;j++);
}

void delay_us(int count)  // /* X1us */
{
    int i,j;
        for(i=0;i<count;i++)
            for(j=0;j<1;j++);
}

void SPI_init(void)	
{
	SPCTL = (SSIG << 7)+(SPEN << 6)+(DORD << 5)+(MSTR << 4)+(CPOL << 3)+(CPHA << 2)+SPEED_16;
}

void SPI_WriteByte(u8 byte)
{			
	SPDAT = byte;		//һֽ
	while((SPSTAT & SPIF)==0)	;	//ȴ
	SPSTAT = SPIF+WCOL;			//0 SPIFWCOL־
}

void LCD_WR_REG(u8 Reg)	 
{	
	LCD_CS=0;
	LCD_RS=0;
	SPI_WriteByte(Reg);
	LCD_CS=1;
} 

void LCD_WR_DATA(u8 Data)
{
	LCD_CS=0;
	LCD_RS=1;
	SPI_WriteByte(Data);
	LCD_CS=1;
}

void LCD_WriteReg(u8 LCD_Reg, u8 LCD_RegValue)
{
	LCD_WR_REG(LCD_Reg);
	LCD_WR_DATA(LCD_RegValue);
}

void LCD_SetWindows(u16 xStar, u16 yStar,u16 xEnd,u16 yEnd)
{	
	LCD_WR_REG(SET_X_ADD_CMD);	
	LCD_WR_DATA(xStar>>8);
	LCD_WR_DATA(xStar);		
	LCD_WR_DATA(xEnd>>8);
	LCD_WR_DATA(xEnd);
	LCD_WR_REG(SET_Y_ADD_CMD);	
	LCD_WR_DATA(yStar>>8);
	LCD_WR_DATA(yStar);		
	LCD_WR_DATA(yEnd>>8);
	LCD_WR_DATA(yEnd);
	LCD_WR_REG(WR_RAM_CMD);	//ʼдGRAM				
}   

void LCD_Clear(u16 Color)
{
	u16 i,j;
	LCD_SetWindows(0,0,width-1,height-1);	
	LCD_CS=0;
	LCD_RS=1;
  for(i=0;i<width;i++)
	{
	  for (j=0;j<height;j++)
	   	{
			SPI_WriteByte(Color>>8);
			SPI_WriteByte(Color);
	    }
	}
	LCD_CS=1;
}

void LCD_Reset(void)
{	
	LCD_RESET=0;
	delay_ms(20);
	LCD_RESET=1;
	delay_ms(20);
}

void LCD_direction(u8 direction)
{ 
	switch(direction%4){		  
		case 0:						 	 		
			width=LCD_W;
			height=LCD_H;	
			LCD_WriteReg(0x36,1<<3);//BGR==1,MY==0,MX==0,MV==0
		break;
		case 1:
			width=LCD_H;
			height=LCD_W;
			LCD_WriteReg(0x36,(1<<3)|(1<<5)|(1<<6));//BGR==1,MY==1,MX==0,MV==1
		break;
		case 2:						 	 		
			width=LCD_W;
			height=LCD_H;		
			LCD_WriteReg(0x36,(1<<3)|(1<<7)|(1<<6));//BGR==1,MY==0,MX==0,MV==0
		break;
		case 3:
			width=LCD_H;
			height=LCD_W;
			LCD_WriteReg(0x36,(1<<3)|(1<<7)|(1<<5));//BGR==1,MY==1,MX==0,MV==1
		break;	
		default:break;
	}		
}

void LCD_Init(void)
{
	LCD_Reset(); //ʼ֮ǰλ
//*************ILI9341Vʼ**********//
	LCD_WR_REG(0xCF);
	LCD_WR_DATA(0x00);
	LCD_WR_DATA(0xC1);
	LCD_WR_DATA(0x30);
	LCD_WR_REG(0xED);
	LCD_WR_DATA(0x64);
	LCD_WR_DATA(0x03);
	LCD_WR_DATA(0x12);
	LCD_WR_DATA(0x81);
	LCD_WR_REG(0xE8);
	LCD_WR_DATA(0x85);
	LCD_WR_DATA(0x00);
	LCD_WR_DATA(0x7A);
	LCD_WR_REG(0xCB);
	LCD_WR_DATA(0x39);
	LCD_WR_DATA(0x2C);
	LCD_WR_DATA(0x00);
	LCD_WR_DATA(0x34);
	LCD_WR_DATA(0x02);
	LCD_WR_REG(0xF7);
	LCD_WR_DATA(0x20);
	LCD_WR_REG(0xEA);
	LCD_WR_DATA(0x00);
	LCD_WR_DATA(0x00);
	LCD_WR_REG(0xc0);
	LCD_WR_DATA(0x21);
	LCD_WR_REG(0xc1);
	LCD_WR_DATA(0x11);
	LCD_WR_REG(0xC5); //VCM control
	LCD_WR_DATA(0x3F);
	LCD_WR_DATA(0x3C);
	LCD_WR_REG(0xc7);
	LCD_WR_DATA(0xaa);
	LCD_WR_REG(0x36);
	LCD_WR_DATA(0x08);
	LCD_WR_REG(0xb6);
	LCD_WR_DATA(0x0a);
	LCD_WR_DATA(0xA2);
	LCD_WR_REG(0xb1);
	LCD_WR_DATA(0x00);
	LCD_WR_DATA(0x1B);
	LCD_WR_REG(0xf2);
	LCD_WR_DATA(0x00);
	LCD_WR_REG(0x26);
	LCD_WR_DATA(0x01);
	LCD_WR_REG(0x3a);
	LCD_WR_DATA(0x55);
	LCD_WR_REG(0xE0); //Set Gamma
	LCD_WR_DATA(0x0F);
	LCD_WR_DATA(0x23);
	LCD_WR_DATA(0x1F);
	LCD_WR_DATA(0x0B);
	LCD_WR_DATA(0x0E);
	LCD_WR_DATA(0x08);
	LCD_WR_DATA(0x4B);
	LCD_WR_DATA(0XA8);
	LCD_WR_DATA(0x3B);
	LCD_WR_DATA(0x0A);
	LCD_WR_DATA(0x14);
	LCD_WR_DATA(0x06);
	LCD_WR_DATA(0x10);
	LCD_WR_DATA(0x09);
	LCD_WR_DATA(0x00);
	LCD_WR_REG(0XE1); //Set Gamma
	LCD_WR_DATA(0x00);
	LCD_WR_DATA(0x1C);
	LCD_WR_DATA(0x20);
	LCD_WR_DATA(0x04);
	LCD_WR_DATA(0x10);
	LCD_WR_DATA(0x08);
	LCD_WR_DATA(0x34);
	LCD_WR_DATA(0x47);
	LCD_WR_DATA(0x44);
	LCD_WR_DATA(0x05);
	LCD_WR_DATA(0x0B);
	LCD_WR_DATA(0x09);
	LCD_WR_DATA(0x2F);
	LCD_WR_REG(0x11);
	delay_ms(120);
	LCD_WR_REG(0x29);		
//	LCD_BL=1;//	 
}

//
void main(void)
{ 
	u8 i=0;
	//STC_12LE5A60S2ƬP3.2ΪڿƱ
	//ͨC51Ƭ޴
	//P3M1 &= ~(1<<2),P3M0 |=  (1<<2); 
	SPI_init(); //ʼӲSPI
	//Һʼ
	LCD_Init();

	//ѭи	
	while(1)
	{
		LCD_direction(i++);
		LCD_Clear(WHITE);delay_ms(1000);
		LCD_Clear(BLACK);delay_ms(1000);
		LCD_Clear(RED);delay_ms(1000);
		LCD_Clear(GREEN);delay_ms(1000);
		LCD_Clear(BLUE);delay_ms(1000);
		if(i>3)
		{
			i=0;
		}
	}   
}
